#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 167772161, g = 3, ginv = 55924054;
const int N = 1e6+5;

int M(int x){return (x%mod+mod)%mod;}

int fastpow(int x,int y){
	int ans=1;
	for(;y;y>>=1,x=M(x*x)){
		if(y&1) ans=M(ans*x);
	}
	return ans;
}

namespace poly{
	int ws[N],r[N];
	void ntt(int *a,int n){
    	for(int i=0;i<n;i++){
        	if(i<r[i]) swap(a[i],a[r[i]]);
		}
    	for(int i=2;i<(n<<1);i<<=1){
        	int w1=ws[i];
        	for(int j=0;j<n;j+=i){
            	int w=1;
            	for(int k=0;k<(i>>1);k++,w=M(w*w1)){
                	int x=a[j+k],y=a[j+k+(i>>1)];
                	a[j+k]=M(x+w*y);
                	a[j+k+(i>>1)]=M(x-w*y);
            	}
        	}
    	}
	}
	void init(int &n, int m){
		int c=1,l=0;
    	while(c<=n+m) l++,c<<=1;
    	n=c;
		for(int i=0;i<=n;i++) r[i]=(r[i>>1]>>1)|((i&1)<<(l-1));
	}
	void NTT(int *a, int n){
		for(int i=1;i<=n;i++) ws[i]=fastpow(g, (mod-1)/i);
		ntt(a, n);
	}
	void DNTT(int *a, int n){
		for(int i=1;i<=n;i++) ws[i]=fastpow(ginv, (mod-1)/i);
		ntt(a, n);
		int inv=fastpow(n,mod-2);
		for(int i=0;i<=n;i++) a[i] = M(a[i] * inv);
	}
	void mul(int *a, int *b, int n, int m){
		poly::init(n, m);
		poly::NTT(a, n);poly::NTT(b, n);
		for(int i=0;i<n;i++) a[i] = M(a[i] * b[i]);
		poly::DNTT(a, n);
	}
}

int a[N], b[N], inv[N], n;

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    cin >> n;
    inv[1] = inv[0] = 1;
    for(int i=2;i<=n;i++) inv[i] = (mod - mod / i) * inv[mod % i] % mod;
    for(int i=2;i<=n;i++) inv[i] = inv[i-1] * inv[i] % mod;
    for(int i=0;i<=n;i++) a[i] = M((i & 1 ? -1 : 1) * inv[i]);
    for(int i=0;i<=n;i++) b[i] = M(fastpow(i, n) * inv[i]);
    poly::mul(a, b, n, n);
    for(int i=0;i<=n;i++) cout << a[i] << " ";
    return 0;
}
