#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 1e9 + 7, K = 5005;
int n, k, f[K][K], fact = 1, binom = 1, ans, pw2, inv[K];

int fastpow(int a, int b){
	if(!b) return 1;
	if(b == 1) return a % mod;
	int ans = fastpow(a, b >> 1);
	ans = ans * ans % mod;
	if(b & 1) ans = ans * a % mod;
	return ans;
}

signed main(){
	ios::sync_with_stdio(false);
	cin >> n >> k;
	f[0][0] = 1;
	for(int i=1;i<=k;i++){
		for(int j=1;j<=i;j++){
			f[i][j] = (f[i - 1][j - 1] + (j * f[i - 1][j] % mod)) % mod;
		}
	}
	inv[1] = 1;
	for(int i=2;i<=k;i++) inv[i] = ((mod - mod / i) * inv[mod % i]) % mod;
	pw2 = fastpow(2, n - 1);
	for(int i=1;i<=k;i++){
		fact = fact * i % mod;
		binom = (binom * (n - i + 1) % mod) * inv[i] % mod;
		ans = (ans + ((fact * binom % mod) * f[k][i] % mod) * pw2 % mod) % mod;
		pw2 = pw2 * inv[2] % mod;
	}
	cout << ans;
	return 0;
}